/*
 *  Albert Seward Copyright (C) 2005
 *  All Rights Reserved. Proprietary.
 *  alse7905@student.uu.se
 * 
 */

#ifndef _DELAY_H_
#define _DELAY_H_

#include <avr/io.h>

#undef __SFR_OFFSET
#define __SFR_OFFSET 0

#ifdef __ASM__

/*
 * wait <number of cycles>, <register to use for count>
 *
 * Inline delay between 0 to 765 cycles.
 * Will use maximum 5 program words.
 * 
 */
.macro wait_loop cycles, temp
  .if ((\cycles) > 765)
    _wait_loop (\cycles)/2, \temp
    _wait_loop (\cycles) - (\cycles)/2, \temp
  .else
    _wait_loop (\cycles), \temp
  .endif
.endm
	

.macro _wait_loop cycles, temp
  .if ((\cycles) > 765)
     .print "Wait macro: To high wait value!"
    .abort    
  .elseif ((\cycles) < 0)
    .print "Wait macro: Negative wait value!"
    .abort
  .endif
	
  .if ((\cycles) < 3)
  
    .if ((\cycles) >= 1)
      nop
      .if ((\cycles) >= 2)
        nop
      .endif
    .endif
  
  .else	
    ldi     	\temp, ((\cycles) / 3)
100:
    dec         \temp
    brne    	100b
    
    .if (((\cycles) % 3) >= 1)
      nop
      .if (((\cycles) % 3) >= 2)
        nop
      .endif
    .endif
	
  .endif

.endm
#else /* __ASM__ */
/* TODO: Write C wrapper here */
#endif  /* !__ASM__ */

#endif /* _DELAY_H_ */

