/*
 * Albert Seward Copyright (C) 2005
 * All Rights Reserved. Proprietary.
 * alse7905@student.uu.se
 *  
 * Graphic Driver Mode0
 *
 */

#include <avr/io.h>
#include "mode0.h"
#include "video.h"
#include "delay.h"

;#define __SFR_OFFSET 0

.extern __ramp
.extern _pgmp
.extern _scrp

.lcomm line_count, 1
.lcomm col_count, 1

/* Register use */
#define	r_ram_bitmap_L	r22
#define	r_ram_bitmap_H  r23
#define	r_pgm_bitmap_L  r21
#define	r_pgm_bitmap_H  r25
#define tmp1		r24     
#define	tmp3		r18    
#define	tmp4		r19
#define	tmp5		r20    
#define carg0		r24
// r0, r1, X, Y, Z

mode0:
.global mode0

	lds             r0, TCNT1L
	;lds             r1, TCNT1H
	sbrs            r0, 0
	rjmp            1f
1:
   	;nop
	;nop
	lds             r0, TCNT1L
	;lds             r1, TCNT1H
	sbrs            r0, 1
	rjmp            1f
	nop
	nop
	nop
1:
	push		YL
	push		YH

	wait_loop	MODE0_XPOS, tmp3

	lds    		YL, _scrp
	lds    		YH, _scrp+1
	lds		r_ram_bitmap_L, __ramp
	lds		r_ram_bitmap_H, __ramp+1
	lds		r_pgm_bitmap_L, _pgmp
	lds		r_pgm_bitmap_H, _pgmp+1
	ldi		tmp5, MODE0_BLOCK_SIZE

	ldi		tmp3, 205
	mul		carg0, tmp3
	lsr		r1
	lsr		r1
	lsr		r1
	mov		tmp3, r1

	ldi		tmp4, MODE0_COLUMNS
	mul		tmp3, tmp4
	add		YL, r0
	adc		YH, r1	
	
	ldi  	      	tmp4, 10
	mul		tmp3, tmp4
	sub		carg0, r0
	lsl		carg0
	lsl		carg0
	
	eor		r1, r1
	add		r_pgm_bitmap_L, carg0
	adc		r_pgm_bitmap_H, r1
	add		r_ram_bitmap_L, carg0
	adc		r_ram_bitmap_H, r1

	ld		tmp4, Y+
	ldi		tmp3, MODE0_COLUMNS
	mul		tmp4, tmp5
	movw		XL, r0
	add		r0, r_pgm_bitmap_L	       
	adc		r1, r_pgm_bitmap_H	      	
	cpi		tmp4, MODE0_PGM_BLOCK_COUNT
	
	brsh		rstart
	movw		ZL, r0 			       	
	lpm		tmp1, Z+	
	dec		tmp3
	
pgm:	out		VIDEO_PORT, tmp1
	ld		tmp4, Y+
1:	swap		tmp1	
       	in		r0, SREG
	out		VIDEO_PORT, tmp1		
	lpm		tmp1, Z+
       	bst		r0, 1
	
	out		VIDEO_PORT, tmp1
	swap		tmp1
	mul		tmp4, tmp5
        movw		XL, r0
	out		VIDEO_PORT, tmp1	
	lpm		tmp1, Z+
	add		r0, r_pgm_bitmap_L
		
	out		VIDEO_PORT, tmp1
	swap		tmp1
        adc		r1, r_pgm_bitmap_H	
        brts  	 	2f
	subi		tmp4, MODE0_PGM_BLOCK_COUNT
	out		VIDEO_PORT, tmp1	
	lpm		tmp1, Z+
	movw		ZL, r0
	
	out		VIDEO_PORT, tmp1
	swap		tmp1
        brsh		ram        
	
	ld		tmp4, Y+
	out		VIDEO_PORT, tmp1
       	dec		tmp3
	lpm		tmp1, Z+	
	out		VIDEO_PORT, tmp1	
	rjmp		1b
	
2:	out		VIDEO_PORT, tmp1	
	lpm		tmp1, Z+
	nop
	
done:	out		VIDEO_PORT, tmp1
	swap		tmp1
	sbiw	     	YL, MODE0_COLUMNS +1
	eor		tmp3, tmp3			
	out		VIDEO_PORT, tmp1	
	pop		YH
	nop
	out		VIDEO_PORT, tmp3	
	pop		YL
	ret
	
_pgm:	ld		tmp1, X+
	out		VIDEO_PORT, tmp1		 
	swap		tmp1
	lpm		r0, Z+	
	out		VIDEO_PORT, tmp1
       	dec		tmp3
	mov		tmp1, r0 	
	rjmp		pgm


ram:	nop
	out		VIDEO_PORT, tmp1
	
rstart:	add 		XL, r_ram_bitmap_L
	adc		XH, r_ram_bitmap_H
	ld		tmp1, X+		
	out		VIDEO_PORT, tmp1		 
	swap		tmp1		
	ld		tmp4, Y+       	
        nop 
	out		VIDEO_PORT, tmp1		 
	
	mul		tmp4, tmp5
       	ld		tmp1, X+       	
	out		VIDEO_PORT, tmp1		 
     	swap		tmp1
	movw		ZL, r0
        nop
        nop
	out		VIDEO_PORT, tmp1		 

        add		ZL, r_pgm_bitmap_L
	adc		ZH, r_pgm_bitmap_H	 
       	ld		tmp1, X+       	
	out		VIDEO_PORT, tmp1		 
     	swap		tmp1
	dec		tmp3	
	breq		2f
	subi		tmp4, MODE0_PGM_BLOCK_COUNT
	out		VIDEO_PORT, tmp1		 

	brlo		_pgm
       	ld		tmp1, X+
       	movw		XL, r0
	out		VIDEO_PORT, tmp1		 
     	swap		tmp1
	rjmp		ram

2:	out		VIDEO_PORT, tmp1		 
	ld		tmp1, X+
	rjmp		done
